From b75f59424cbf4e55174c34e4406dc75cc81c071a Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Sep 02 2020 17:18:46 +0000
Subject: [PATCH 837/2232] Log the include directories


On build script failure, the output looks like:

    running: "c++" "-O0" "-ffunction-sections" "-fdata-sections" "-fPIC" "-g" "-fno-omit-frame-pointer" "-m64" "-I" "/git/cxx/target/cxxbridge" "-I" "/git/cxx/target/cxxbridge/CRATE" "-Wall" "-Wextra" "-std=c++14" "-o" "/git/cxx/target/debug/build/demo-33ada9770433c2cc/out/src/demo.o" "-c" "src/demo.cc"
    cargo:warning=src/demo.cc:2:10: fatal error: path/to/nonexistent.rs.h: No such file or directory
    cargo:warning=    2 | #include "path/to/nonexistent.rs.h"
    cargo:warning=      |          ^~~~~~~~~~~~~~~~~~~~~~~~~~
    cargo:warning=compilation terminated.
    exit code: 1

    --- stderr

    CXX include path:
      /git/cxx/target/cxxbridge
      /git/cxx/target/cxxbridge/CRATE

    error occurred: Command "c++" "-O0" "-ffunction-sections" "-fdata-sections" "-fPIC" "-g" "-fno-omit-frame-pointer" "-m64" "-I" "/git/cxx/target/cxxbridge" "-I" "/git/cxx/target/cxxbridge/CRATE" "-Wall" "-Wextra" "-std=c++14" "-o" "/git/cxx/target/debug/build/demo-33ada9770433c2cc/out/src/demo.o" "-c" "src/demo.cc" with args "c++" did not execute successfully (status code exit code: 1).

---

diff --git a/gen/build/src/lib.rs b/gen/build/src/lib.rs
index 9498fe2..ef284c4 100644
--- a/gen/build/src/lib.rs
+++ b/gen/build/src/lib.rs
@@ -123,17 +123,24 @@ impl Project {
 
 fn build(rust_source_files: &mut dyn Iterator<Item = impl AsRef<Path>>) -> Result<Build> {
     let ref prj = Project::init()?;
+    let include_dir = paths::include_dir(prj);
+
     let mut build = Build::new();
     build.cpp(true);
     build.cpp_link_stdlib(None); // linked via link-cplusplus crate
-    build.include(paths::include_dir(prj));
+    build.include(&include_dir);
     write_header(prj);
-    symlink_crate(prj, &mut build);
+    let crate_dir = symlink_crate(prj, &mut build);
 
     for path in rust_source_files {
         generate_bridge(prj, &mut build, path.as_ref())?;
     }
 
+    eprintln!("\nCXX include path:");
+    eprintln!("  {}", include_dir.display());
+    if let Some(crate_dir) = crate_dir {
+        eprintln!("  {}", crate_dir.display());
+    }
     Ok(build)
 }
 
@@ -148,20 +155,21 @@ fn write_header(prj: &Project) {
     }
 }
 
-fn symlink_crate(prj: &Project, build: &mut Build) {
+fn symlink_crate(prj: &Project, build: &mut Build) -> Option<PathBuf> {
     let manifest_dir = match paths::manifest_dir() {
         Some(manifest_dir) => manifest_dir,
-        None => return,
+        None => return None,
     };
     let package_name = match paths::package_name() {
         Some(package_name) => package_name,
-        None => return,
+        None => return None,
     };
 
     let mut link = paths::include_dir(prj);
     link.push("CRATE");
     let _ = out::symlink_dir(manifest_dir, link.join(package_name));
-    build.include(link);
+    build.include(&link);
+    Some(link)
 }
 
 fn generate_bridge(prj: &Project, build: &mut Build, rust_source_file: &Path) -> Result<()> {

